// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package drawer

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// DrawerClient is the client API for Drawer service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type DrawerClient interface {
	// OpenDrawer requests to open the drawer
	OpenDrawer(ctx context.Context, in *OpenDrawerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type drawerClient struct {
	cc grpc.ClientConnInterface
}

func NewDrawerClient(cc grpc.ClientConnInterface) DrawerClient {
	return &drawerClient{cc}
}

func (c *drawerClient) OpenDrawer(ctx context.Context, in *OpenDrawerRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.posperipherals.drawer.Drawer/OpenDrawer", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// DrawerServer is the server API for Drawer service.
// All implementations must embed UnimplementedDrawerServer
// for forward compatibility
type DrawerServer interface {
	// OpenDrawer requests to open the drawer
	OpenDrawer(context.Context, *OpenDrawerRequest) (*emptypb.Empty, error)
	mustEmbedUnimplementedDrawerServer()
}

// UnimplementedDrawerServer must be embedded to have forward compatible implementations.
type UnimplementedDrawerServer struct {
}

func (UnimplementedDrawerServer) OpenDrawer(context.Context, *OpenDrawerRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method OpenDrawer not implemented")
}
func (UnimplementedDrawerServer) mustEmbedUnimplementedDrawerServer() {}

// UnsafeDrawerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to DrawerServer will
// result in compilation errors.
type UnsafeDrawerServer interface {
	mustEmbedUnimplementedDrawerServer()
}

func RegisterDrawerServer(s grpc.ServiceRegistrar, srv DrawerServer) {
	s.RegisterService(&Drawer_ServiceDesc, srv)
}

func _Drawer_OpenDrawer_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(OpenDrawerRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(DrawerServer).OpenDrawer(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.posperipherals.drawer.Drawer/OpenDrawer",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(DrawerServer).OpenDrawer(ctx, req.(*OpenDrawerRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Drawer_ServiceDesc is the grpc.ServiceDesc for Drawer service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Drawer_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.posperipherals.drawer.Drawer",
	HandlerType: (*DrawerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "OpenDrawer",
			Handler:    _Drawer_OpenDrawer_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/vis/posperipherals/drawer/drawer.proto",
}
